//---------------------------------------------------------------------------
// zdrojovy kod programu pro obsluhu serioveho portu v prostredi WINDOWS 32
// podporuje platformu WIN9x i platformu NT vcetne W2000 a XP
#include <vcl.h>
#pragma hdrstop
#pragma package(smart_init)
#include "Comm.h"
//---------------------------------------------------------------------------
// dekodovani vyjmenovanych typu
// udalosti serioveho portu
DWORD CommEventList[] = { EV_BREAK,EV_CTS,EV_DSR,EV_ERR,EV_RING,
                          EV_RLSD,EV_RXCHAR,EV_RXFLAG,EV_TXEMPTY };
// prenosove rychlosti
DWORD CommBaudRates[] = { CBR_110,CBR_300,CBR_600,CBR_1200,CBR_2400,CBR_4800,
                          CBR_9600,CBR_14400,CBR_19200,CBR_38400,CBR_56000,
                          CBR_57600,CBR_115200,CBR_128000,CBR_256000 };
// parametru prenosoveho ramce
BYTE CommParity[] = { NOPARITY,EVENPARITY,ODDPARITY,MARKPARITY,SPACEPARITY };
BYTE CommStopBits[] = { ONESTOPBIT,ONE5STOPBITS,TWOSTOPBITS };
BYTE CommDataBits[] = { 4,5,6,7,8 };
//---------------------------------------------------------------------------
// procedura zobrazi vzniklou chybu obsluhy serioveho portu
void RaiseCommError( String Msg,int ErrCode )
{
     throw Exception( Msg+Format(sMsgExtention,ARRAYOFCONST(((int)ErrCode))) );
}
//---------------------------------------------------------------------------
// konstruktor objektu obsluzneho procesu udalosti serioveho portu
__fastcall TCommEventThread::TCommEventThread( HANDLE Handle,
                               TCommEventTypes MonitorEvents ):TThread( true )
{
   int i ;
   DWORD AttrWord = 0;
   FreeOnTerminate = true;
   FCommHandle = Handle;
     for (i=0;i<9;i++) {                    // cykl tvorby masky udalosti
         if ( MonitorEvents.Contains(TCommEventType(i)) ) //
            AttrWord += CommEventList[i];   //
     }                                      // ok
     SetCommMask( FCommHandle,AttrWord );   // zapis masky udalosti do portu
}
//---------------------------------------------------------------------------
// procedura spusteni obsluhy vazeb
void __fastcall TCommEventThread::Execute( void )
{
   OVERLAPPED os;
   bool WaitEventResult;
     memset( &os,0,sizeof(OVERLAPPED) );
     os.hEvent = CreateEvent( NULL,TRUE,FALSE,NULL );
     while ( !Terminated ) {                // cykl obsluhy udalosti
        WaitEventResult = WaitCommEvent( FCommHandle,
                                  &FEventMask,&os ); // start cekani na udalost
        if ( GetLastError()==ERROR_IO_PENDING ) // neni hotovo ?
           WaitEventResult = ( WaitForSingleObject( // tady se fyzicky ceka
               os.hEvent,INFINITE)==WAIT_OBJECT_0 ); // ok
        if ( WaitEventResult>0 ) {          // test vyskytu udalosti
           Synchronize( DoOnSignal );       // volani procedury obsluhy udalosti
           ResetEvent( os.hEvent );         // reset udalosti
        }                                   // ok
     }
     CloseHandle( os.hEvent );              // obsluha pri likvidaci procesu
     PurgeComm( FCommHandle,PurgeReadWrite ); // ok
}
//---------------------------------------------------------------------------
// volaci procedura obsluhy udalosti portu
void __fastcall TCommEventThread::DoOnSignal( void )
{
     if ( FOnSignal )
        FOnSignal( this,FEventMask);
}
//---------------------------------------------------------------------------
// konstruktor objektu uzivatelsky definovanych ridicich znaku komunikace
__fastcall TCommEventChars::TCommEventChars( TThreadComm *Owner ):TPersistent()
{
     FOwner = Owner;                        // inicializace promennych
     FXOnChar = 17;                         //
     FXOffChar = 19;                        //
     FErrorChar = 0;                        //
     FEofChar = 0;                          //
     FEvtChar = 0;                          // ok
}
//---------------------------------------------------------------------------
// procedura zapisu novych ridicich znaku komunikace
void __fastcall TCommEventChars::SetEventChar( int Index,char Value )
{
     switch ( Index ) {                     // detekce znaku
       case 1: FXOnChar = Value;   break;   //
       case 2: FXOffChar = Value;  break;   //
       case 3: FErrorChar = Value; break;   //
       case 4: FEofChar = Value;   break;   //
       case 5: FEvtChar = Value;   break;   //
     }                                      // ok
     if ( FOwner!=NULL )                    // zapis do ridici struktury DCB
        FOwner->UpdateDataControlBlock();   // ok
}
//---------------------------------------------------------------------------
// procedura prirazeni ridiciho znaku komunikace
void __fastcall TCommEventChars::Assign( TPersistent *Source )
{
   TCommEventChars *TempControl;
     TempControl = dynamic_cast <TCommEventChars*>( Source );
     if ( TempControl!=NULL ) {             // prirazeni znaku
        FXOnChar = TempControl->FXOnChar;   //
        FXOffChar = TempControl->FXOffChar; //
        FErrorChar = TempControl->FErrorChar; //
        FEofChar = TempControl->FEofChar;   //
        FEvtChar = TempControl->FEvtChar;   //
     }                                      // ok
       else
            TPersistent::Assign( Source );  // volani procedury predka
}
//---------------------------------------------------------------------------
// konstruktor objektu obsluhy serioveho portu
__fastcall TThreadComm::TThreadComm( TComponent* Owner )
    : TComponent( Owner )
{
     FHandle = INVALID_HANDLE_VALUE;        // inicializace internich promennych
     FDeviceName = "COM1";                  //
     FReadTimeout = 1000;                   //
     FWriteTimeout = 1000;                  //
     FReadBufSize = 4096;                   //
     FWriteBufSize = 4096;                  //
     FMonitorEvents <<evBreak<<evCts<<evDsr<<evError<<evRing; //
     FMonitorEvents <<evRlsd<<evRxChar<<evRxFlag<<evTxEmpty; //
     FBaudRate = br9600;                    //
     FParity = paNone;                      //
     FStopBits = sb10;                      //
     FDataBits = da8;                       //
     FFlowControl = fcDefault;              //
     FConnected = false;                    // ok
     WRITE_OS.Offset = 0;                   // rizeni udalosti zapisu
     WRITE_OS.OffsetHigh = 0;               //
     WRITE_OS.hEvent = CreateEvent( NULL,TRUE,FALSE,NULL ); // ok
     READ_OS.Offset = 0;                    // rizeni udalosti cteni
     READ_OS.OffsetHigh = 0;                //
     READ_OS.hEvent = CreateEvent( NULL,TRUE,FALSE,NULL ); // ok
     FEventChars = new TCommEventChars( this ); // objekt znaku rizeni komunikace
     FEvent = new TSimpleEvent();           // objekt udalosti pro R/W
     FCriticalSection = new TCriticalSection(); // objekt rizeni procesu vazeb
}
//---------------------------------------------------------------------------
// destruktor objektu obsluhy serioveho portu
__fastcall TThreadComm::~TThreadComm( void )
{
     Close();                               // uzavreni portu
     FEventChars->Free();                   // uvolneni znaku rizeni komunikace
     FEvent->Free();                        // uvolneni R/W udalosti
     FCriticalSection->Free();              // uvolneni rizeni procesu vazeb
     CloseHandle( WRITE_OS.hEvent );        // likvidace udalosti cteni a zapisu
     CloseHandle( READ_OS.hEvent );         // ok
}
//---------------------------------------------------------------------------
// procedura uzamkne v objektu portu vsechny procesy vazeb
void __fastcall TThreadComm::Lock( void )
{
     FCriticalSection->Enter();
}
//---------------------------------------------------------------------------
// procedura uvolni v objektu portu vsechny procesy vazeb
void __fastcall TThreadComm::Unlock( void )
{
     FCriticalSection->Leave();
}
//---------------------------------------------------------------------------
// funkce zjisti stav otevreni serioveho portu
bool __fastcall TThreadComm::Enabled( void )
{
     return FConnected;
}
//---------------------------------------------------------------------------
// procedura vytvori handle pro pristup k seriovemu portu
void __fastcall TThreadComm::CreateHandle( void )
{
     FHandle = CreateFile( FDeviceName.c_str(),GENERIC_READ|GENERIC_WRITE,
                           0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|
                           FILE_FLAG_OVERLAPPED,NULL );
     if ( FHandle==INVALID_HANDLE_VALUE ) { // test otevreni portu
        FConnected = false;                 // chyba otevreni
        return;                             //
     }                                      // ok
     FConnected = true;                     // port otevren
     if ( GetFileType(FHandle)!=FILE_TYPE_CHAR ) // test typu zarizeni
        DestroyHandle();                    // neni to znakova konsole
     else                                   //
          SetCommMask( FHandle,511 );       // ok, nastavit masku udalosti
}
//---------------------------------------------------------------------------
// procedura zlikviduje handle otevreneho portu
void __fastcall TThreadComm::DestroyHandle( void )
{
     CloseHandle( FHandle );                // uzavreni handle
     FConnected = false;                    // port neni otevren
     FHandle = INVALID_HANDLE_VALUE;        // handle neotevreno
}
//---------------------------------------------------------------------------
// procedura otevre seriovy port
void __fastcall TThreadComm::Open( HANDLE ModemHandle )
{
   int Error_Code = 0;
   String ErrorString;
     Lock();                                // uzamceni vsech procesu vazeb
     if ( !Enabled() ) {
        if ( ModemHandle!=NULL ) {          // test obsluhy portu modemu
           FHandle = ModemHandle;           // je to modem, predat handle
           FConnected = true;               // ok
        }                                   //
          else
               CreateHandle();              // otevrit handle serioveho portu
        if ( Enabled() ) {                  // handle otevreno
           if ( ModemHandle==NULL )         // u modemu nenastavovat DCB
              UpdateDataControlBlock();     // to pak nastavime v TAPI
           UpdateCommTimeouts();            // nastaveni timeoutu portu
           if ( !SetupComm(FHandle,FReadBufSize,FWriteBufSize)) { // nastaveni
              Error_Code = GetLastError();  // velikosti R/W bufferu portu
              ErrorString = sSetupCommErr;  //
           }                                // ok
           FEventThread = new TCommEventThread( FHandle,FMonitorEvents ); // spusteni
           FEventThread->OnSignal = HandleCommEvent; // procesu vazeb udalosti
           FEventThread->Resume();          //
           if ( FEventThread==NULL )        //
              DestroyHandle() ;             // ok
        }
     }
       else
            {                               // port je jiz otevren
              Error_Code = -1;              //
              ErrorString = sPortAlreadyOpen; //
            }                               // ok
     Unlock();                              // odemceni vsech procesu vazeb
     if ( Error_Code!=0 )                   // chybove hlaseni, kdyz existuje
        RaiseCommError( ErrorString,Error_Code ); // ok
}
//---------------------------------------------------------------------------
// procedura uzavre seriovy port
void __fastcall TThreadComm::Close( void )
{
     if ( Enabled() ) {                     // uzavrit pouze otevreny port
        Lock();                             // uzamceni vsech procesu vazeb
        try {
           FEventThread->OnSignal = NULL ;  // clr obsluhy procesu vazeb
           TerminateThread( (void*)FEventThread->Handle,0 ); // ok
           DestroyHandle();                 // likvidace handle portu
        }
        catch (...) { Unlock(); }           // odemceni vsech procesu vazeb
        Unlock();                           // ok
     }
}
//---------------------------------------------------------------------------
// funkce zapise retezec do serioveho portu
int __fastcall TThreadComm::Write( char Buf[],DWORD Count )
{
   BOOL fWriteStat;
   DWORD dwBytesWritten;
   DWORD dwErrorFlags;
   DWORD dwError;
   DWORD dwBytesSent = 0;
   COMSTAT ComStat;
     if ( !Enabled() )                      // port neni otevren
        return -1;                          // nelze vysilat data
     Lock();                                // uzamceni vsech procesu vazeb
     try {                                  // zapis dat
       fWriteStat = WriteFile( FHandle,Buf,Count,&dwBytesWritten,&WRITE_OS ); //
       if ( !fWriteStat ) {
          if ( GetLastError()==ERROR_IO_PENDING ) { // zapis neni ukoncen
             while ( !GetOverlappedResult(FHandle,&WRITE_OS, // cykl a test stavu
                                          &dwBytesWritten,FALSE) ) { // zapisu
               dwError = GetLastError();    //
               if ( dwError==ERROR_IO_INCOMPLETE ) { // jeste neni hotovo
                 dwBytesSent += dwBytesWritten; // pricist pocet odeslanych dat
                 continue;                  // dalsi test stavu
               }
               ClearCommError( FHandle,&dwErrorFlags,&ComStat ); // clr chyb portu
               break;                       // konec testu stavu, data odeslana
             }
             dwBytesSent += dwBytesWritten; // pricist pocet odeslanych dat
          }
            else
                 ClearCommError( FHandle,&dwErrorFlags,&ComStat ); // clr chyb portu
       }
         else
              dwBytesSent = dwBytesWritten; // pocet primo odeslanych dat
     }
     catch (...) { Unlock(); }              // odemceni vsech procesu vazeb
     Unlock();                              // ok
     return dwBytesSent;                    // vratit pocet odeslanych byte
}
//---------------------------------------------------------------------------
// funkce nacte retezec ze serioveho portu
int __fastcall TThreadComm::Read( char Buf[],DWORD Count )
{
   BOOL fReadStat;
   COMSTAT ComStat;
   DWORD dwErrorFlags;
   DWORD dwLength;
   DWORD dwBytesReceive = 0;
   DWORD dwError;
     if ( !Enabled() )                      // port neni otevren
        return -1;                          // nelze cist data
     Lock();                                // uzamceni vsech procesu vazeb
     try {                                  // cteni dat
       ClearCommError( FHandle,&dwErrorFlags,&ComStat ); // clr chyb portu
       dwLength =  Count ;                  // a zjisteni statusu
       if ( dwLength>0 ) {                  // cist pouze nenulovy retezec
          fReadStat = ReadFile( FHandle,Buf,dwLength,&dwLength,&READ_OS ); //
          if ( !fReadStat ) {
             if ( GetLastError()==ERROR_IO_PENDING ) { // cteni neni dokonceno
                while ( !GetOverlappedResult(FHandle,&READ_OS, // cykl a test stavu
                                             &dwLength,TRUE ) ) { // cteni
                  dwError = GetLastError(); //
                  if ( dwError==ERROR_IO_INCOMPLETE ) { // jeste neni hotovo
                     dwBytesReceive += dwLength; // pricist pocet prijatych dat
                     continue;              // dalsi test stavu
                  }
                  ClearCommError( FHandle,&dwErrorFlags,&ComStat ); // clr chyb portu
                  break;                    // konec testu stavu, data prijata
                }
                dwBytesReceive += dwLength; // pricist pocet prijatych dat
             }
               else
                    ClearCommError( FHandle,&dwErrorFlags,&ComStat ); // clr chyb portu
          }
            else
                 dwBytesReceive = dwLength; // pocet primo prijatych dat
       }
     }
     catch (...) { Unlock(); }              // odemceni vsech procesu vazeb
     Unlock();                              // ok
     return dwBytesReceive;                 // vrati pocet prijatych byte
}
//---------------------------------------------------------------------------
// funkce zjisti pocet byte v prijimacim bufferu portu
int __fastcall TThreadComm::InQueCount( void )
{
   COMSTAT ComStat;
   DWORD Errors;
   int Result;
     if ( Enabled() ) {                     // je-li port otevren
        ClearCommError( FHandle,&Errors,&ComStat ); // clr chyb a nacteni statusu
        Result = ComStat.cbInQue;           // prenos poctu byte
     }                                      // ok
       else
            Result = -1;                    // nic se nenacetlo
     return Result;                         // vratit pocet byte
}
//---------------------------------------------------------------------------
// funkce zjisti pocet byte ve vysilacim bufferu portu
int __fastcall TThreadComm::OutQueCount( void )
{
   COMSTAT ComStat;
   DWORD Errors;
   int Result ;
     if ( Enabled() ) {                     // je-li port otevren
        ClearCommError( FHandle,&Errors,&ComStat ); // clr chyb a nacteni statusu
        Result = ComStat.cbOutQue;          // prenos poctu byte
     }                                      // ok
       else
            Result = -1;                    // nic se nenacetlo
     return Result;                         // vrati pocet byte
}
//---------------------------------------------------------------------------
// procedura stornuje vsechny operace cteni a vymaze cteci buffer
void __fastcall TThreadComm::PurgeIn( void )
{
     if ( Enabled() )                       // port otevren
        PurgeComm( FHandle,PurgeRead );     // provest
}
//---------------------------------------------------------------------------
// procedura stornuje vsechny operace zapisu a vymaze zapisovy buffer
void __fastcall TThreadComm::PurgeOut( void )
{
     if ( Enabled() )                       // port otevren
        PurgeComm( FHandle,PurgeWrite );    // provest
}
//---------------------------------------------------------------------------
// procedura nastavi nazev pouziteho serioveho portu
void __fastcall TThreadComm::SetDeviceName( String Value )
{
     if ( !Enabled()&&(FDeviceName!=Value) ) // port uzavren a je rozdil
        FDeviceName = Value;                 // provest
}
//---------------------------------------------------------------------------
// procedura nastvi promennou monitorovanych udalosti portu
void __fastcall TThreadComm::SetMonitorEvents( TCommEventTypes Value )
{
    if ( !Enabled()&&(FMonitorEvents!=Value) ) // port uzavren a je rozdil
       FMonitorEvents = Value;              // provest
}
//---------------------------------------------------------------------------
// procedura nastavi promennou velikosti bufferu cteni
void __fastcall TThreadComm::SetReadBufSize( WORD Value )
{
     if ( !Enabled()&&(FReadBufSize!=Value) ) // port uzavren a je rozdil
        FReadBufSize = Value;               // provest
}
//---------------------------------------------------------------------------
// procedura nastavi promennou velikosti bufferu zapisu
void __fastcall TThreadComm::SetWriteBufSize( WORD Value )
{
     if ( !Enabled()&&(FWriteBufSize!=Value) ) // port uzavren a je rozdil
        FWriteBufSize = Value;              // provest
}
//---------------------------------------------------------------------------
// procedura nastvi prenosovou rychlost portu
void __fastcall TThreadComm::SetBaudRate( TBaudRate Value )
{
     if ( FBaudRate!=Value ) {              // je rozdil
        FBaudRate = Value;                  // provest
        Lock();                             //
        UpdateDataControlBlock();           //
        Unlock();                           // ok
     }
}
//---------------------------------------------------------------------------
// procedura nastavi typ parity prenosu
void __fastcall TThreadComm::SetParity( TParity Value )
{
     if ( FParity!=Value ) {                // je rozdil
        FParity = Value;                    // provest
        Lock();                             //
        UpdateDataControlBlock();           //
        Unlock();                           // ok
     }
}
//---------------------------------------------------------------------------
// procedura nastavi pocet stopbitu prenosu
void __fastcall TThreadComm::SetStopBits( TStopBits Value )
{
     if ( FStopBits!=Value ) {              // je rozdil
        FStopBits = Value;                  // provest
        Lock();                             //
        UpdateDataControlBlock();           //
        Unlock();                           // ok
     }
}
//---------------------------------------------------------------------------
// procedura nastavi pocet datovych bitu prenosu
void __fastcall TThreadComm::SetDataBits( TDataBits Value )
{
     if ( FDataBits!=Value ) {              // je rozdil
        FDataBits = Value;                  // provest
        Lock();                             //
        UpdateDataControlBlock();           //
        Unlock();                           // ok
     }
}
//---------------------------------------------------------------------------
// procedura nastavi vlastnosti datoveho pranosu
void __fastcall TThreadComm::SetOptions( TCommOptions Value )
{
     if ( FOptions!=Value ) {               // je rozdil
        FOptions = Value;                   // provest
        Lock();                             //
        UpdateDataControlBlock();           //
        Unlock();                           // ok
     }
}
//---------------------------------------------------------------------------
// procedura nastavi typ rizeni datoveho prenosu
void __fastcall TThreadComm::SetFlowControl( TFlowControl Value )
{
     if ( FFlowControl!=Value ) {           // je rozdil
        FFlowControl = Value;               // provest
        Lock();                             //
        UpdateDataControlBlock();           //
        Unlock();                           // ok
     }
}
//---------------------------------------------------------------------------
// procedura obsluhy reakci na monitorovane udalosti portu
void __fastcall TThreadComm::HandleCommEvent( TObject *Sender,DWORD Status )
{
   COMSTAT ComStat;
   DWORD Errors;
     ClearCommError( FHandle,&Errors,&ComStat ); // clr chyb a nacteni statusu
     if ( (Status&EV_BREAK)>0 )             // reakce na stav BREAK
        if ( FOnBreak )                     //
           FOnBreak( this );                // ok
     if ( (Status&EV_CTS)>0 )               // reakce na signal CTS
        if ( FOnCts )                       //
           FOnCts( this );                  // ok
     if ( (Status&EV_DSR)>0 )               // reakce na signal DSR
        if ( FOnDsr )                       //
           FOnDsr( this );                  // ok
     if ( (Status&EV_ERR)>0 )               // reakce na chybu portu
        if ( FOnError )                     //
           FOnError( this,Errors );         // ok
     if ( (Status&EV_RING)>0 )              // reakce na signal RING
        if ( FOnRing )                      //
           FOnRing( this );                 // ok
     if ( (Status&EV_RLSD)>0 )              // reakce na signal RLSD
        if ( FOnRlsd )                      //
           FOnRlsd( this );                 // ok
     if ( (Status&EV_RXCHAR)>0 )            // reakce na prijem znaku
        if ( ComStat.cbInQue>0 )            //
           if ( FOnRxChar )                 //
              FOnRxChar( this,ComStat.cbInQue ); // ok
     if ( (Status&EV_RXFLAG)>0 )            // reakce na prijem ridiciho znaku
        if ( FOnRxFlag )                    //
           FOnRxFlag( this );               // ok
     if ( (Status&EV_TXEMPTY)>0 )           // reakce na vyprazdneni bufferu vysilace
        if ( FOnTxEmpty )                   //
           FOnTxEmpty( this );              // ok
     if ( FCommStatEvent )                  // reakce na obecnou udalost portu
        FCommStatEvent( this,Status,ComStat); // ok
}
//---------------------------------------------------------------------------
// funkce nacte stav vybraneho signalu modemu portu
bool __fastcall TThreadComm::GetModemState( int Index )
{
   DWORD Flag,State;
   bool Result = false;
     switch ( Index ) {                     // detekce pozadovaneho stavu
       case 1:  State = MS_CTS_ON;  break;  //
       case 2:  State = MS_DSR_ON;  break;  //
       case 3:  State = MS_RING_ON; break;  //
       case 4:  State = MS_RLSD_ON; break;  //
       default: State = 0;          break;  // ok
     }
     if ( Enabled() )                       // nacteni a vypocet vybraneho stavu
        if ( GetCommModemStatus(FHandle,&Flag) ) //
           Result = ( (Flag&State)>0 );     //
     return Result ;                        // vraci nacteny stav
}
//---------------------------------------------------------------------------
// funkce nacte stav vybraneho signalu portu
bool __fastcall TThreadComm::GetComState( int Index )
{
   COMSTAT ComStat;
   DWORD Errors;
   bool Result;

     if ( !Enabled() )                      // port neni otevren
        return false;                       // nic nedelat
     ClearCommError( FHandle,&Errors,&ComStat ); // zjisteni stavu portu
     switch ( Index ) {                     // detekce vybraneho stavu
       case 1:  Result = ComStat.fCtsHold;  break; //
       case 2:  Result = ComStat.fDsrHold;  break; //
       case 3:  Result = ComStat.fRlsdHold; break; //
       case 4:  Result = ComStat.fXoffHold; break; //
       case 5:  Result = ComStat.fXoffSent; break; //
       default: Result = ComStat.fCtsHold;  break; // ok
     }
     return Result;                         // vrati vybrany stav portu
}
//---------------------------------------------------------------------------
// procedura nastavi ridici strukturu serioveho portu
void __fastcall TThreadComm::UpdateDataControlBlock( void )
{
   bool Result;
     if ( !Enabled() )                      // port neni otevren
        return;                             // nic nedelat
     SetupComm( FHandle,FReadBufSize,FWriteBufSize ); // velikost RW bufferu portu
     GetCommState( FHandle,&FDCB );         // nacteni nastaveni portu z windows
     FDCB.BaudRate = CommBaudRates[FBaudRate]; // nastveni parametru portu
     FDCB.Parity = CommParity[FParity];     //
     FDCB.StopBits = CommStopBits[FStopBits]; //
     FDCB.ByteSize = CommDataBits[FDataBits]; //
     FDCB.XonChar = FEventChars->XOnChar;   //
     FDCB.XoffChar = FEventChars->XOffChar; //
     FDCB.ErrorChar = FEventChars->ErrorChar; //
     FDCB.EofChar = FEventChars->EofChar;   //
     FDCB.EvtChar = FEventChars->EvtChar;   //
     FDCB.XonLim = 1024;                    //
     FDCB.XoffLim = 1024;                   //
     FDCB.fParity = FOptions.Contains( coParityCheck ); //
     FDCB.fDsrSensitivity = FOptions.Contains( coDsrSensitivity ); //
     FDCB.fTXContinueOnXoff = FOptions.Contains( coIgnoreXOff ); //
     FDCB.fErrorChar = FOptions.Contains( coErrorChar ); //
     FDCB.fNull = FOptions.Contains( coNullStrip ); //
     Result = SetCommState( FHandle,&FDCB ); //
     if ( !Result )                         // osetreni chyby nastaveni DCB
        RaiseCommError( sUpdateDCBErr,GetLastError() ); // ok
}
//---------------------------------------------------------------------------
// procedura nastavi escape signaly portu
void __fastcall TThreadComm::EscapeComm( int Flag )
{
   bool Escaped;
     if ( Enabled() ) {
        Lock();                             // uzamknout vsechny procesy vazeb
        Escaped = EscapeCommFunction( FHandle,Flag ); // nastaveni signalu
        Unlock();                           // odemknout vsechny procesy vazeb
        if ( !Escaped )                     // osetreni chyby nastaveni
           RaiseCommError( sEscFuncError,GetLastError() ); // ok
     }
       else
            RaiseCommError( sPortNotOpen,-1 ); // chyba, port neni otevren
}
//---------------------------------------------------------------------------
// procedura nastavi signal DTR
void __fastcall TThreadComm::SetDTRState( bool State )
{
   int DTR[] = { CLRDTR,SETDTR };
     EscapeComm( DTR[State] );
}
//---------------------------------------------------------------------------
// procedura nastavi signal RTS
void __fastcall TThreadComm::SetRTSState( bool State )
{
   int RTS[] = { CLRRTS,SETRTS };
     EscapeComm( RTS[State] );
}
//---------------------------------------------------------------------------
// procedura nastavi stav BREAK
void __fastcall TThreadComm::SetBREAKState( bool State )
{
   int BREAK[] = { CLRBREAK,SETBREAK };
     EscapeComm( BREAK[State] );
     if ( Enabled() ) {                     // reset udalosti a bufferu portu
        Lock();                             //
        PurgeComm( FHandle,PurgeReadWrite ); //
        Unlock();                           // ok
     }
}
//---------------------------------------------------------------------------
// procedura nastavi stav XON nebo XOFF
void __fastcall TThreadComm::SetXONState( bool State )
{
   int XON[] = { SETXOFF,SETXON };
     EscapeComm( XON[State] );
}
//---------------------------------------------------------------------------
// procedura nastavi timeouty cteni a zapisu serioveho portu
void __fastcall TThreadComm::UpdateCommTimeouts( void )
{
   COMMTIMEOUTS CommTimeOuts;
   bool Result;
     CommTimeOuts.ReadIntervalTimeout = MAXDWORD; // nastaveni timeoutu
     CommTimeOuts.ReadTotalTimeoutMultiplier = 0 ; //
     CommTimeOuts.ReadTotalTimeoutConstant = FReadTimeout; //
     CommTimeOuts.WriteTotalTimeoutMultiplier = 0; //
     CommTimeOuts.WriteTotalTimeoutConstant = FWriteTimeout; // ok
     Result = SetCommTimeouts(FHandle, &CommTimeOuts) ; // prenos do portu
     if ( !Result )                         // osetreni chyby nastaveni
        RaiseCommError( sCommTimeoutsErr,GetLastError() ); // ok
}
//---------------------------------------------------------------------------