//---------------------------------------------------------------------------
// zdrojovy kod programu obsluhy telefonniho modemu v prostredi TAPI ver.1.4
// podporuje platformu WIN9x i platformu NT vcetne W2000 a XP
#include <vcl.h>
#pragma hdrstop
#pragma package(smart_init)
#include "modem.h"
//---------------------------------------------------------------------------
// globalni promenne modemu
TThreadComm *ModemPort;                     // seriovy port modemu
TStringList *ModemList;                     // seznam nainstalovanych modemu
HLINEAPP LineApp = 0;		            // identifikace prostredi TAPI
HLINE Line = 0;	                            // handle linky spojeni
HCALL Call = 0;  			    // handle volani v TAPI
DWORD tapiVersion = 0;                      // verze TAPI
DWORD DeviceID = 0;       	            // identifikace vybraneho modemu
LINECALLPARAMS CallParams;	            // parametry volani
AnsiString ActCallNum = "";                 // aktualni vytocene cislo
AnsiString ActualModem = "";                // nazev otevreneho modemu
DWORD ConnectRate = 0;                      // rychlost navazaneho spojeni
void CALLBACK LineCallback( DWORD hDevice,DWORD dwMsg,DWORD dwCallbackInstance,
			    DWORD dwParam1, DWORD dwParam2, DWORD dwParam3 );
//---------------------------------------------------------------------------
// procedura inicializuje prostredi TAPI a vyplni list nainstalovanych modemu
void __fastcall InitializeTAPI( void )
{
   DWORD x, needed, DeviceCount;
   LPLINEDEVCAPS DevCaps;
   LINEEXTENSIONID extid;
   int index;
   long result;
     ModemList = new TStringList();         // vytvoreni objektu listu modemu
     if ( lineInitialize(&LineApp,HInstance,LineCallback, // otevreni TAPI
          (LPCSTR)Application->ExeName.c_str(),&DeviceCount)<0 ) {
        LineApp = 0;                        // TAPI nejde otevrit
        return;                             // nic nedelat
     }
     if ( DeviceCount==0 ) {                // zadny modem neni nainstalovan ?
        lineShutdown( LineApp );            // likvidace TAPI
        LineApp = 0;                        //
        return;                             // ok
     }
     for ( x=0;x<DeviceCount;x++ ) {        // pruzkum nainstalovanych zarizeni
         if ( lineNegotiateAPIVersion(LineApp,x,0x00010000, // test verze TAPI
                                      0x00090000,&tapiVersion,&extid)<0 )
            continue;                       // nezarazovat nepodporovany modem
         DevCaps = (LPLINEDEVCAPS)new BYTE[sizeof(LINEDEVCAPS)]; // velikost
         memset( DevCaps,0,sizeof(LINEDEVCAPS) ); // struktury vlastnosti modemu
         DevCaps->dwTotalSize = sizeof( LINEDEVCAPS ); //
         result = lineGetDevCaps( LineApp,x,tapiVersion,0,DevCaps ); //
         needed = DevCaps->dwNeededSize;    // ok
         delete DevCaps;
         if ( (result<0)&&(result!=(long)LINEERR_STRUCTURETOOSMALL) ) // chyba
            continue;                       // nezarazovat do listu modemu
         DevCaps = (LPLINEDEVCAPS)new BYTE[needed]; // vlastnosti zarizeni
         memset( DevCaps,0,needed );        //
         DevCaps->dwTotalSize = needed;     //
         if ( lineGetDevCaps(LineApp,x,tapiVersion,0,DevCaps)<0 ) { // cteni
            delete DevCaps;                 // nelze nacist
            continue;                       // nezarazovat do listu modemu
         }
         if ( DevCaps->dwMediaModes&LINEMEDIAMODE_DATAMODEM ) { // je to modem ?
            index = ModemList->Add( (char*)DevCaps+
                                    DevCaps->dwLineNameOffset ); // nazev modemu
            ModemList->Objects[index] = (TObject *)x; // cislo identifikace
         }
         delete DevCaps;
     }
     ModemPort = new TThreadComm( NULL );  // vytvoreni objektu portu modemu
}
//---------------------------------------------------------------------------
// procedura zlikviduje prostredi TAPI
void __fastcall DestroyTAPI( void )
{
     if ( Call )                            // rozpojeni modemu
        lineDeallocateCall( Call );         // ok
     if ( Line )                            // uzavreni linky
        lineClose( Line );                  // ok
     if ( LineApp )                         // uzavreni prostredi TAPI
	lineShutdown( LineApp );            // ok
     LineApp = 0;                           // clr vsech handle
     Line = 0;                              //
     Call = 0;                              // ok
     ModemList->Clear();                    // clr listu nainstalovanych modemu
     delete ModemPort;                      // likvidace objektu portu modemu
}
//---------------------------------------------------------------------------
// procedura otevre specifikovany modem
void __fastcall OpenModem( AnsiString Name )
{
   int index;
   LPDEVICECONFIG DeviceConfig;
   DWORD Needed;
   AnsiString Text;
     for ( index=0;index<ModemList->Count;index++ ) // test existence modemu
         if ( ModemList->Strings[index]==Name ) //
            goto ID0;                       // modem nalezen
     Text = "Modem "+Name+" not found.";    //
     Application->MessageBox( Text.c_str(),"Command error.",MB_OK); // ohlaseni chyby
     return;
 ID0:if ( Call ) {                          // likvidace spojeni modemu
        lineDeallocateCall( Call );         //
        Call = 0;                           //
     }                                      // ok
     if ( Line ) {                          // existuje-li linka, pak zavrit
        lineClose( Line );                  //
        Line = 0;                           //
     }                                      // ok
     DeviceID = (DWORD)ModemList->Objects[index]; // identifikace linky
     strnset( (LPSTR)&CallParams,'\0',sizeof(CallParams) ); // parametry vytaceni
     CallParams.dwTotalSize = sizeof( CallParams ); //
     CallParams.dwBearerMode = LINEBEARERMODE_VOICE; // hlasova linka
     CallParams.dwMediaMode = LINEMEDIAMODE_DATAMODEM; // datovy modem
     CallParams.dwMaxRate = 19200;          // tak se nastavuje interval prenosovych
     CallParams.dwMinRate = 19200;          // rychlosti portu volaneho modemu
     DeviceConfig = new DEVICECONFIG;       // konfigurace mistniho modemu
     memset( DeviceConfig,0,sizeof(DEVICECONFIG) ); //
     DeviceConfig->vs.dwTotalSize = sizeof( DEVICECONFIG ); //
     lineGetDevConfig( DeviceID,(LPVARSTRING)DeviceConfig,"comm/datamodem" ); //
     Needed = DeviceConfig->vs.dwNeededSize; // zjistena velikost struktury
     delete DeviceConfig;
     if ( Needed ) {                        // nactena velikost struktury
        DeviceConfig = (LPDEVICECONFIG)new BYTE[Needed]; //
        memset( DeviceConfig,0,Needed );    //
        DeviceConfig->vs.dwTotalSize = Needed; //
        lineGetDevConfig( DeviceID,(LPVARSTRING)DeviceConfig,"comm/datamodem" ); //
        memset(&DeviceConfig->commconfig.dcb,0,
               sizeof(DeviceConfig->commconfig.dcb) );// clr struktury DCB modemu
        BuildCommDCB( "19200,n,8,1",&DeviceConfig->commconfig.dcb ); // DCB modemu
        lineSetDevConfig( DeviceID,(LPVOID)&DeviceConfig->dwSize,
               DeviceConfig->dwSize,"comm/datamodem"); // nastaveni mistniho modemu
        delete DeviceConfig;
      }
      if ( lineOpen(LineApp,DeviceID,&Line,tapiVersion,0,0, // otevreni linky
                LINECALLPRIVILEGE_NONE,LINEMEDIAMODE_DATAMODEM,&CallParams)==0 )
         ActualModem = Name;                // prenos nazvu otevreneho modemu
}
//---------------------------------------------------------------------------
// procedura navaze datove spojeni modemu
void __fastcall Startup( void )
{
   MODEM_INFO ModemInfo;
     ModemInfo.vs.dwTotalSize = sizeof(MODEM_INFO); // nacteni informaci o modemu
     ModemInfo.vs.dwStringFormat = STRINGFORMAT_BINARY; //
     ModemInfo.hComm = INVALID_HANDLE_VALUE; //
     lineGetID( Line,0,0,LINECALLSELECT_LINE,(LPVARSTRING)&ModemInfo,
                                      "comm/datamodem" ); //
     if ( ModemInfo.hComm==INVALID_HANDLE_VALUE ) { // chyba handle portu modemu
        Application->MessageBox("Invalid communication port handle.",
                                "Modem line error.",MB_OK); // ohlaseni chyby
        return;
     }
     ModemPort->Open( ModemInfo.hComm );    // otevreni serioveho portu modemu
     if ( !ModemPort->Connected )           // test navazani spojeni
        Application->MessageBox("Communication port not connected.",
                                "Modem line error.",MB_OK); // ohlaseni chyby
}
//---------------------------------------------------------------------------
// procedura ukonci datove spojeni portu modemu
void __fastcall Shutdown( void )
{
     ConnectRate = 0;                       // clr prenosove rychlosti
     ActCallNum = "";                       // clr aktualniho cisla spojeni
     ModemPort->Close();                    // uzavreni serioveho portu modemu
}
//---------------------------------------------------------------------------
// procedura obslouzi reakce na udalosti v TAPI
void CALLBACK LineCallback( DWORD hDevice,DWORD dwMsg,DWORD dwCallbackInstance,
			    DWORD dwParam1, DWORD dwParam2, DWORD dwParam3 )
{
   char LineCallBuf[1024];
   bool MemBit;
     switch ( dwMsg ) {
       case LINE_REPLY:                     // hlaseni modemu
         if ( (long)dwParam2<0 )            // chyba modemu
            Application->MessageBox("Modem in use or not found.",
                                    "Fatal error.",MB_OK); // hlaseni o chybe
       break;
       case LINE_CLOSE:                     // uzavreni linky modemu
	 Line = 0;                          //
         DeviceID = 0;                      //
         ActualModem = "";                  // ok
       break;
       case LINE_CALLSTATE:                 // osetreni odchoziho volani
         switch ( dwParam1 ) {
           case LINECALLSTATE_IDLE:         // modem je necinny
             Shutdown();                    // uvolneni portu modemu
             if ( Call ) {                  // likvidace spojeni
                lineDeallocateCall( Call ); //
                Call = 0;                   // ok
             }
           break;
	   case LINECALLSTATE_CONNECTED:    // navazani spojeni s portem
             ((LPLINECALLINFO)LineCallBuf)->dwTotalSize = sizeof( LineCallBuf );
	     if ( lineGetCallInfo(Call,     // prenosova rychlost spojeni
                                 (LPLINECALLINFO)LineCallBuf)==0 ) { //
                ConnectRate = ((LPLINECALLINFO)LineCallBuf)->dwRate; //
	        Startup();                  // otevreni potu modemu
             }
	   break;
	   case LINECALLSTATE_DISCONNECTED: // rozpojeni linky
             MemBit = ModemPort->Connected; // pamet spojeni portu
             Shutdown();                    // uzavreni portu modemu
             if ( Call )                    // likvidace spojeni
                lineDrop(Call,NULL,0);      // ok
             if ( MemBit )                  // port bul propojen
                Application->MessageBox("Line disconnected.",
                                 "Modem line error.",MB_OK); // hlaseni o chybe
	   break;
           case LINECALLSTATE_DIALING:      // vytaceni cisla
             // zde muze byt program pro obsluhu vytaceni cisla
	   break;
           case LINECALLSTATE_OFFERING:     // vyzvaneni
             // zde muze byt program pro obsluhu odchoziho vyzvaneni
	   break;
           case LINECALLSTATE_PROCEEDING:   // navazovani spojeni modemu
             // zde muze byt program pro obsluhu navazovani spojeni
	   break;
	   case LINECALLSTATE_BUSY:         // protistanice obsazena
             Application->MessageBox("Modem busy.","Modem line error.",MB_OK);
	   break;
	   default:
	   break;
         }
       break;
       default:
       break;
     }
}
//---------------------------------------------------------------------------
// procedura vytoci pozadovane cislo
void __fastcall Dial( AnsiString Number,bool PulseDial )
{
   AnsiString CallNum;
     if ( Call )                            // pri existenci spojeni
        return;                             // nevolat dalsi
     if ( Number=="" ) {                    // test prazdneho retezce cisla
        Application->MessageBox("Call Number buffer empty.",
                                "Command error.",MB_OK); // ohlaseni chyby
        return;
     }
     CallNum = ( PulseDial )?"P":"T";       // nastaveni typu volby
     CallNum += Number;                     // vytvoreni volaneho cisla
     if ( lineMakeCall(Line,&Call,CallNum.c_str(),0,&CallParams)<0 ) { // vytaceni
        Application->MessageBox("Can't create call.",
                                "Modem line error.",MB_OK); // ohlaseni chyby
        return;
     }
     ActCallNum = Number;                   // pamet zadaneho cisla
}
//---------------------------------------------------------------------------
// procedura zavesi modem
void __fastcall HangUp( void )
{
     if ( Call ) {                         // likvidace spojeni linky
        Shutdown();                        // uzavreni portu modemu
        lineDrop( Call,NULL,0 );           // zaveseni modemu
     }
}
//---------------------------------------------------------------------------
